// 
// Copyright (c) 2008 smdn <smdn@smdn.jp>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

using Smdn.Net.Imap4.Protocol.DataStructures;

namespace Smdn.Net.Imap4.Client {
  partial class ImapMessage {
    /*
     * OpenRead()
     */
    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead()
      => Body.Download();

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapMessageFetchBodyOptions options)
      => Body.Download(options: options);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapFetchRange? fetchRange)
      => Body.Download(fetchRange: fetchRange ?? ImapFetchRange.All);

    [Obsolete("use Body.Read(Action<Stream>) or Body.Download() instead")]
    public Stream OpenRead(ImapFetchRange? fetchRange,
                           ImapMessageFetchBodyOptions options)
      => Body.Download(options: options, fetchRange: fetchRange ?? ImapFetchRange.All);

    /*
     * ReadAs<TResult>(Converter<Stream>)
     */
    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(Converter<Stream, TResult> converter)
      => Body.ReadAs(converter);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(ImapMessageFetchBodyOptions options,
                                   Converter<Stream, TResult> converter)
      => Body.ReadAs(converter, options);

    /*
     * ReadAs<TResult>(Func<Stream, ...>)
     */
    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T, TResult>
      (Func<Stream, T, TResult> read, T arg)
      => Body.ReadAs(read, arg);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, TResult>
      (Func<Stream, T1, T2, TResult> read, T1 arg1, T2 arg2)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2), (arg1, arg2));

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, T3, TResult>
      (Func<Stream, T1, T2, T3, TResult> read, T1 arg1, T2 arg2, T3 arg3)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2, a.arg3), (arg1, arg2, arg3));

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, T3, T4, TResult>
      (Func<Stream, T1, T2, T3, T4, TResult> read, T1 arg1, T2 arg2, T3 arg3, T4 arg4)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2, a.arg3, a.arg4), (arg1, arg2, arg3, arg4));

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T, TResult>
      (ImapMessageFetchBodyOptions options,
       Func<Stream, T, TResult> read, T arg)
      => Body.ReadAs(read, arg, options);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, TResult>
      (ImapMessageFetchBodyOptions options,
       Func<Stream, T1, T2, TResult> read, T1 arg1, T2 arg2)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2), (arg1, arg2), options);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, T3, TResult>
      (ImapMessageFetchBodyOptions options,
       Func<Stream, T1, T2, T3, TResult> read, T1 arg1, T2 arg2, T3 arg3)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2, a.arg3), (arg1, arg2, arg3), options);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<T1, T2, T3, T4, TResult>
      (ImapMessageFetchBodyOptions options,
       Func<Stream, T1, T2, T3, T4, TResult> read, T1 arg1, T2 arg2, T3 arg3, T4 arg4)
      => Body.ReadAs((s, a) => read(s, a.arg1, a.arg2, a.arg3, a.arg4), (arg1, arg2, arg3, arg4), options);

    /*
     * ReadAllBytes()
     */
    [Obsolete("use Body.ReadAsByteArray() instead")]
    public byte[] ReadAllBytes()
      => Body.ReadAsByteArray();

    [Obsolete("use Body.ReadAsByteArray() instead")]
    public byte[] ReadAllBytes(ImapMessageFetchBodyOptions options)
      => Body.ReadAsByteArray(options);

    /*
     * WriteTo(Stream)
     */
    [Obsolete("use Body.WriteTo() instead")]
    public void WriteTo(Stream stream)
      => Body.WriteTo(stream);

    [Obsolete("use Body.WriteTo() instead")]
    public void WriteTo(Stream stream,
                        ImapMessageFetchBodyOptions options)
      => Body.WriteTo(stream, options);

    /*
     * WriteTo(BinaryWriter)
     */
    [Obsolete("use Body.WriteTo() instead")]
    public void WriteTo(BinaryWriter writer)
      => Body.WriteTo(writer);

    [Obsolete("use Body.WriteTo() instead")]
    public void WriteTo(BinaryWriter writer,
                        ImapMessageFetchBodyOptions options)
      => Body.WriteTo(writer, options);

    /*
     * Save()
     */
    [Obsolete("use Body.Save() instead")]
    public void Save(string path)
      => Body.Save(path);

    [Obsolete("use Body.Save() instead")]
    public void Save(string path,
                     ImapMessageFetchBodyOptions options)
      => Body.Save(path, options);

    /*
     * Download()
     */
    [Obsolete("use Body.Download() instead")]
    public Stream Download()
      => Body.Download();

    [Obsolete("use Body.Download() instead")]
    public Stream Download(ImapMessageFetchBodyOptions options)
      => Body.Download(options);

    /*
     * OpenText
     */
    [Obsolete("use Body.Read(Action<StreamReader>) or Body.ReadAsString() instead")]
    public StreamReader OpenText()
      => Body.ReadAs(OpenTextConverter, arg: default(int), forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.Read(Action<StreamReader>) or Body.ReadAsString() instead")]
    public StreamReader OpenText(ImapMessageFetchBodyOptions options)
      => Body.ReadAs(OpenTextConverter, arg: default(int), options: options, forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.Read(Action<StreamReader>) or Body.ReadAsString() instead")]
    public StreamReader OpenText(Encoding charset)
      => Body.ReadAs(OpenTextConverter, arg: default(int), forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.Read(Action<StreamReader>) or Body.ReadAsString() instead")]
    public StreamReader OpenText(Encoding charset,
                                 ImapMessageFetchBodyOptions options)
      => Body.ReadAs(OpenTextConverter, arg: default(int), options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete]
    internal static StreamReader OpenTextConverter(Stream bodyStream, Encoding contentCharset, int _)
      => new StreamReader(ImapMessageBody.Download(bodyStream), contentCharset); // TODO: remove ImapMessageBody.Download

    /*
     * ReadAs<TResult>(Converter<StreamReader>)
     */
    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(Converter<StreamReader, TResult> converter)
      => Body.ReadAs(converter);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(ImapMessageFetchBodyOptions options,
                                   Converter<StreamReader, TResult> converter)
      => Body.ReadAs(converter, options);

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(Encoding charset,
                                   Converter<StreamReader, TResult> converter)
      => Body.ReadAs(converter, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAs() instead")]
    public TResult ReadAs<TResult>(Encoding charset,
                                   ImapMessageFetchBodyOptions options,
                                   Converter<StreamReader, TResult> converter)
      => Body.ReadAs(converter, options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    /*
     * ReadLines()
     */
    [Obsolete("use Body.ReadAsStringLines() instead")]
    public IEnumerable<string> ReadLines()
      => Body.ReadAsStringLines(forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public IEnumerable<string> ReadLines(ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringLines(options: options, forceCharsetTo: ImapMessageBodyBase.DefaultCharset);

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public IEnumerable<string> ReadLines(Encoding charset)
      => Body.ReadAsStringLines(forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public IEnumerable<string> ReadLines(Encoding charset,
                                         ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringLines(options: options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    /*
     * ReadAllLines()
     */
    [Obsolete("use Body.ReadAsStringLines() instead")]
    public string[] ReadAllLines()
      => Body.ReadAsStringLines().ToArray();

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public string[] ReadAllLines(ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringLines(options).ToArray();

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public string[] ReadAllLines(Encoding charset)
      => Body.ReadAsStringLines(forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))).ToArray();

    [Obsolete("use Body.ReadAsStringLines() instead")]
    public string[] ReadAllLines(Encoding charset,
                                 ImapMessageFetchBodyOptions options)
      => Body.ReadAsStringLines(options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset))).ToArray();

    /*
     * ReadAllText()
     */
    [Obsolete("use Body.ReadAsString() instead")]
    public string ReadAllText()
      => Body.ReadAsString();

    [Obsolete("use Body.ReadAsString() instead")]
    public string ReadAllText(ImapMessageFetchBodyOptions options)
      => Body.ReadAsString(options);

    [Obsolete("use Body.ReadAsString() instead")]
    public string ReadAllText(Encoding charset)
      => Body.ReadAsString(forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    [Obsolete("use Body.ReadAsString() instead")]
    public string ReadAllText(Encoding charset,
                              ImapMessageFetchBodyOptions options)
      => Body.ReadAsString(options, forceCharsetTo: charset ?? throw new ArgumentNullException(nameof(charset)));

    /*
     * GetRawHeader(), GetHeader()
     */
    [Obsolete("use Header.ReadAsString() instead")]
    public string GetRawHeader()
      => Header.ReadAsString();

    [Obsolete("use Header.ReadAsString() instead")]
    public string GetRawHeader(params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsString() : Header.ReadAsString(headerFields);

    [Obsolete("use Header.ReadAsString() instead")]
    public string GetRawHeader(/*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsString() : Header.ReadAsString(headerFields);

    [Obsolete("use Header.ReadAsNameValuePairs() instead")]
    public IReadOnlyList<KeyValuePair<string, string>> GetHeader()
      => Header.ReadAsNameValuePairs();

    [Obsolete("use Header.ReadAsNameValuePairs() instead")]
    public IReadOnlyList<KeyValuePair<string, string>> GetHeader(params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairs() : Header.ReadAsNameValuePairs(headerFields: headerFields);

    [Obsolete("use Header.ReadAsNameValuePairs() instead")]
    public IReadOnlyList<KeyValuePair<string, string>> GetHeader(bool decode, params string[] headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairs(decodeHeaderFieldValues: decode) : Header.ReadAsNameValuePairs(headerFields: headerFields, decodeHeaderFieldValues: decode);

    [Obsolete("use Header.ReadAsNameValuePairs() instead")]
    public IReadOnlyList<KeyValuePair<string, string>> GetHeader(/*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairs() : Header.ReadAsNameValuePairs(headerFields: headerFields);

    [Obsolete("use Header.ReadAsNameValuePairs() instead")]
    public IReadOnlyList<KeyValuePair<string, string>> GetHeader(bool decode, /*params*/ IEnumerable<string> headerFields)
      => IsNullOrEmpty(headerFields) ? Header.ReadAsNameValuePairs(decodeHeaderFieldValues: decode) : Header.ReadAsNameValuePairs(headerFields: headerFields, decodeHeaderFieldValues: decode);

    [Obsolete]
    internal static bool IsNullOrEmpty(IEnumerable<string> headerFields)
    {
      if (headerFields == null)
        return true;
      if (headerFields.Count() == 0)
        return true;

      return false;
    }
  }
}

