using System;
using NUnit.Framework;

using Smdn.Net.Imap4.Protocol.Transmission;

namespace Smdn.Net.Imap4.Protocol.DataStructures {
  [TestFixture]
  public class ImapQuotaTests {
    private static ImapQuota FromResponse(string quotaResponse)
    {
      using (var receiver = new ImapPseudoResponseReceiver(quotaResponse)) {
        var response = receiver.ReceiveResponse() as ImapServerDataResponse;

        return ImapServerDataResponseParser.FromQuota(response);
      }
    }

    [Test]
    public void TestResources_MustNotBeNull()
    {
      var quota = FromResponse("* QUOTA \"root\" ()\r\n");

      Assert.IsNotNull(quota.Resources);
      CollectionAssert.IsEmpty(quota.Resources, "Resources");
    }

    [Test]
    public void TestToString()
    {
      var quota = FromResponse("* QUOTA \"root\" (STORAGE 10 512)\r\n");

      Assert.DoesNotThrow(() => quota.ToString());
    }
  }
}

