using System;
using System.Collections.Generic;
using NUnit.Framework;

namespace Smdn.Net.Imap4.Protocol.DataStructures {
  [TestFixture]
  public class ImapUidSetTests {
    [Test]
    public void TestFromUri()
    {
      var set = ImapUidSet.FromUri(new Uri("imap://localhost/INBOX/;UID=1"));

      CollectionAssert.AreEqual(new long[] { 1 }, set);
    }

    [Test]
    public void TestFromUri_InvalidForm()
    {
      var u = new Uri("imap://localhost/INBOX?UID 1");

      Assert.Throws<ArgumentException>(() => ImapUidSet.FromUri(u));
    }
  }
}
