using System;
using NUnit.Framework;

namespace Smdn.Net.Imap4.Protocol.Transmission {
  [TestFixture]
  public class ImapTaggedStatusResponseTests {
    private ImapTaggedStatusResponse CreateFromResponse(string response)
    {
      using (var receiver = new ImapPseudoResponseReceiver(response)) {
        return receiver.ReceiveResponse() as ImapTaggedStatusResponse;
      }
    }

    [Test]
    public void TestSerializeBinary()
    {
      var resp = CreateFromResponse("A142 OK [READ-WRITE] SELECT completed\r\n");

      TestUtils.Assert.IsSerializableBinaryFormat(resp, deserialized => {
        Assert.AreEqual("A142", deserialized.Tag);
        Assert.AreEqual(ImapResponseCondition.Ok, deserialized.Condition);
        Assert.IsNotNull(deserialized.ResponseText);
        Assert.AreEqual(ImapResponseCode.ReadWrite, deserialized.ResponseText.Code);
        Assert.IsNotNull(deserialized.ResponseText.Arguments);
        Assert.AreEqual(0, deserialized.ResponseText.Arguments.Count);
        Assert.AreEqual("SELECT completed", deserialized.ResponseText.Text);
      });
    }
  }
}
