using System;
using NUnit.Framework;

namespace Smdn.Net.Imap4.Protocol.Transmission {
  [TestFixture]
  public class ImapUntaggedStatusResponseTests {
    private ImapUntaggedStatusResponse CreateFromResponse(string response)
    {
      using (var receiver = new ImapPseudoResponseReceiver(response)) {
        return receiver.ReceiveResponse() as ImapUntaggedStatusResponse;
      }
    }

    [Test]
    public void TestSerializeBinary()
    {
      var resp = CreateFromResponse("* OK [UIDVALIDITY 988028003] UID validity status\r\n");

      TestUtils.Assert.IsSerializableBinaryFormat(resp, deserialized => {
        Assert.AreEqual(ImapResponseCondition.Ok, deserialized.Condition);
        Assert.IsNotNull(deserialized.ResponseText);
        Assert.AreEqual(ImapResponseCode.UidValidity, deserialized.ResponseText.Code);
        Assert.IsNotNull(deserialized.ResponseText.Arguments);
        Assert.AreEqual(1, deserialized.ResponseText.Arguments.Count);
        Assert.AreEqual("988028003", deserialized.ResponseText.Arguments[0].GetTextAsString());
        Assert.AreEqual("UID validity status", deserialized.ResponseText.Text);
      });
    }
  }
}
